//---------------------------------------------------------------------------
//
//	BRFileTree.h
//
//	TBRFileTreewb_
//
//---------------------------------------------------------------------------

#ifndef __BRFileTree_H__
#define __BRFileTree_H__

//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>

#if	(_WIN32_IE < 0x0500)
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//!
//---------------------------------------------------------------------------
inline BOOL __fastcall TreeView_GetCheckState(HWND hwndTreeView, HTREEITEM hItem)
{
	TVITEM tvItem;

	tvItem.mask = TVIF_HANDLE | TVIF_STATE;
	tvItem.hItem = hItem;
	tvItem.stateMask = TVIS_STATEIMAGEMASK;

	TreeView_GetItem(hwndTreeView, &tvItem);

	return ((BOOL)(tvItem.state >> 12) -1);
}

//---------------------------------------------------------------------------
//!
//---------------------------------------------------------------------------
inline BOOL __fastcall	TreeView_SetCheckState(HWND hwndTreeView, HTREEITEM hItem, BOOL fCheck)
{
	TVITEM tvItem;

	tvItem.mask = TVIF_HANDLE | TVIF_STATE;
	tvItem.hItem = hItem;
	tvItem.stateMask = TVIS_STATEIMAGEMASK;

	tvItem.state = INDEXTOSTATEIMAGEMASK((fCheck ? 2 : 1));

	return TreeView_SetItem(hwndTreeView, &tvItem);
}
#endif

//---------------------------------------------------------------------------
//!	TBRFileInfoNX
class TBRFileInfo : public TObject
{
private:
	static IShellFolder *mp_desktop;	//!
	static IMalloc *mp_malloc;			//!
	SHFILEINFO		m_sSHFI;			//!
	String			mas_displayName;	//! m[h\
	String			mas_pathName;		//! pX&t@C
	LPITEMIDLIST	mp_idl;				//! m[hITEMIDLISTւ̃|C^
	int				mi_iconIndex;		//! ACRCfbNX
	int				mi_selectedIndex;	//! IC[WCfbNX
	int				mi_openIndex;		//! I[vC[WCfbNX
	int				mi_overlayIndex;	//! I[o[CC[WCfbNX
	DWORD			mdw_attributes;		//! Agr[g
	IShellFolder	*mp_iShellFolder;	//! ̃ACeIShellFolder Interface
	LPVOID			p_data;				//! ֘AtꂽIuWFNgf[^

protected:
	void __fastcall SetPIDL(LPITEMIDLIST p_idl);

public:
	__fastcall	TBRFileInfo(void);
	__fastcall	~TBRFileInfo(void);
	static void __fastcall Init(IShellFolder *p_desktop, IMalloc *p_malloc);
	static void __fastcall Uninit(void);

	__property String DisplayName = {read=mas_displayName,
		write=mas_displayName, nodefault};
	__property LPITEMIDLIST PIDL = {read=mp_idl, write=SetPIDL, default=NULL};
	__property String PathName = {read=mas_pathName, write=mas_pathName,
		nodefault};
	__property int IconIndex = {read=mi_iconIndex, default=-1};
	__property int SelectedIndex = {read=mi_selectedIndex, default=-1};
	__property int OpenIndex = {read=mi_openIndex, default=-1};
	__property int OverlayIndex = {read=mi_overlayIndex, default=-1};
	__property DWORD Attribute = {read=mdw_attributes, default=0};
	__property IShellFolder* ShellFolder = {read=mp_iShellFolder, write=mp_iShellFolder, default=NULL};
	__property LPVOID Data = {read=p_data, write=p_data, default=NULL};
};

//---------------------------------------------------------------------------
//!	TCheckedList
class TBRCheckedList : public TList
{
private:
	TBRFileInfo*	__fastcall	GetItems(int i_idx);
protected:
public:
					__fastcall	TBRCheckedList(void) : TList(){};
				int	__fastcall	Add(TBRFileInfo* Item);

	__property	TBRFileInfo*	Items[int] = {read=GetItems};
};

//---------------------------------------------------------------------------
//!	TBRFileTreeNX
class PACKAGE TBRFileTree : public TCustomTreeView
{
typedef void __fastcall (__closure *TTVAddItemEvent)(System::TObject* Sender, TTreeNode* Node, bool &f_ok);
private:
	IShellFolder	*mp_desktop;		//!
	LPITEMIDLIST	mp_desktopID;		//!
	IMalloc			*mp_malloc;			//!
	bool			mf_forDesktop;		//! fXNgbv̑S\tO
	bool			mf_checkbox;		//! `FbN{bNX\tO
	bool			mf_filtered;		//! gqtB^Lɂ
	String			mas_filterExt;		//! tB^gq
	TStringList		*mp_checkedPath;	//! `FbNς݃pXXg
	DWORD			mdw_enumMask;		//! EnumObjects}XN
	DWORD			mdw_attributeMask;	//! Agr[g}XN

	TTVAddItemEvent	FOnAddItem;

	void __fastcall AddCheckInfo(TTreeNode *p_node, TBRCheckedList *p_list);

protected:
			void __fastcall CreateWnd(void);
	DYNAMIC	bool __fastcall CanExpand(TTreeNode* Node);
	DYNAMIC	bool __fastcall CanCollapse(TTreeNode* Node);
	DYNAMIC	void __fastcall Delete(TTreeNode* Node);

	void __fastcall MyCompareNode(System::TObject* Sender, TTreeNode* Node1, TTreeNode* Node2, int Data, int &Compare);

	void __fastcall CreateChildItems(TTreeNode *p_cParent, String as_pathname);
	int	 __fastcall AddIDL(LPITEMIDLIST p_idlParent,	LPITEMIDLIST p_idlChild, LPITEMIDLIST &p_idlOut);
	bool __fastcall CompareIDList(LPITEMIDLIST p_idl1, LPITEMIDLIST p_idl2);

	void __fastcall WndProc(Messages::TMessage &Message);
public:
	__fastcall TBRFileTree(TComponent* Owner);
	__fastcall ~TBRFileTree(void);

	TTreeNode*	__fastcall AddTopItem(String as_displayName, LPITEMIDLIST p_idl);
	void		__fastcall GetCheckObjects(TBRCheckedList *p_list);

	__property TStringList*	CheckedPath	= {read=mp_checkedPath};
	__property Items;

__published:
	__property bool			CheckBox	= {read=mf_checkbox,	write=mf_checkbox,	default=true};
	__property bool			Filtered	= {read=mf_filtered,	write=mf_filtered,	default=false};
	__property String		FilterExt	= {read=mas_filterExt, write=mas_filterExt,	nodefault};
	__property HideSelection;
	__property SortType;
	__property DWORD		EnumMask	= {read=mdw_enumMask,	write=mdw_enumMask, default=SHCONTF_FOLDERS | SHCONTF_INCLUDEHIDDEN};
	__property DWORD		AttributeMask	= {read=mdw_attributeMask,	write=mdw_attributeMask, default=0xffffffff};

	__property OnChange;
	__property OnMouseDown;
	__property OnMouseUp;
	__property OnClick;
	__property OnDblClick;
	__property OnDragDrop;
	__property OnDragOver;
	__property OnStartDrag;
	__property OnEndDrag;
	__property OnKeyDown;
	__property OnKeyUp;
	__property OnKeyPress;
	__property OnEnter;
	__property OnExit;
	__property TTVAddItemEvent OnAddItem = {read=FOnAddItem, write=FOnAddItem};
};

#endif

